////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define TitleCaption      "SQLBackup"
#define FileVersion       "1.0.0.2"
#define RegistryKey       "Software\\NetWorkDLS\\SQLBackup"
#define Seperator         "______________________________________________________________________________"
#define VirtualDeviceName (unsigned short *)"SQLBackup"

#define DesktopEdition 1000
#define ServerEdition  1001

#define ThisEdition    ServerEdition

//---------------------(HWND & INSTANCE Definitions)
HINSTANCE MainInstance            = NULL;	   // WinMain (Application) Instance
HWND MainDialog_hWnd              = NULL;	   // MainDialog Instance
HWND SplashDialog_hWnd            = NULL;
HWND ViewLogDialog_hWnd           = NULL;

HWND StatusListBox_hWnd           = NULL;

HWND ScheduleDialog_hWnd          = NULL;
HWND ViewScheduleDialog_hWnd      = NULL;
HWND SelectDBDialog_hWnd          = NULL;
HWND SQLPWDDialog_hWnd            = NULL;

HWND ManBackupDialog_hWnd         = NULL;
HWND ManRestoreDialog_hWnd        = NULL;

HWND AddScheduleDialog_hWnd       = NULL;
HWND AddSQLOptionsDialog_hWnd     = NULL;
HWND AddBackupOptionsDialog_hWnd  = NULL;

HWND EditScheduleDialog_hWnd      = NULL;
HWND EditSQLOptionsDialog_hWnd    = NULL;
HWND EditBackupOptionsDialog_hWnd = NULL;

//---------------------(Function Prototypes)
void LBWrite(HWND, char *);
void WriteToLog(char *);
void CloseLogFile(void);
BOOL OpenLogFile(void);
BOOL GetValues(void);
BOOL RestoreJob(char *);
BOOL BackupJob(char *);

DWORD WINAPI SQLProcessThread(LPVOID);
DWORD WINAPI DialogThread(LPVOID);

//---------------------(Global Variables)

BOOL DisplaySplash    = FALSE;
BOOL EndApplication   = FALSE;
BOOL AllOnHold        = FALSE;
BOOL RunningManual    = FALSE;
BOOL CurrentlyRunning = FALSE;
BOOL DoingTransfer    = FALSE;
BOOL CancelFlag       = FALSE;
BOOL StartupComplete  = FALSE;

char TempBackupName[256];
char TempBackupDescription[256];

char SavedDataFile[256];

HANDLE SQLProcessThread_Handle = NULL;
DWORD SQLProcessThread_ID      = 0;

HANDLE DialogThread_Handle = NULL;
DWORD DialogThread_ID      = 0;

FILE *LogFileHandle = NULL;
char LogFileName[256];

BOOL BackupTrusted  = FALSE;
BOOL RestoreTrusted = FALSE;

char MasterDriver[256];
char MasterServer[256];
char MasterDatabase[256];
char MasterUID[256];
char MasterPWS[256];

char BackupServer[256];
char RestoreServer[256];

char BackupDriver[256];
char RestoreDriver[256];

char BackupDataBase[256];
char RestoreDataBase[256];

char BackupFile[256];
char RestoreFile[256];

char BackupUserID[256];
char BackupUserPW[256];
char RestoreUserID[256];
char RestoreUserPW[256];

//---------------------(Global Structures)
struct _SQLProcess{
    int ScheduleItem;
    char DataBase[256];
    char Driver[256];
    BOOL IsTrusted;
    char Server[256];
    char UserID[256];
    char UserPW[256];
    BOOL Backup;
}; _SQLProcess SQLProcess;

//---------------------(Dialog Prototypes)
BOOL CALLBACK MainDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK SplashDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ViewLogDialog(HWND, UINT, WPARAM, LPARAM);

BOOL CALLBACK ScheduleDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ViewScheduleDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK SelectDBDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK SQLPWDDialog(HWND, UINT, WPARAM, LPARAM);

BOOL CALLBACK ManBackupDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ManRestoreDialog(HWND, UINT, WPARAM, LPARAM);

BOOL CALLBACK AddScheduleDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AddSQLOptionsDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AddBackupOptionsDialog(HWND, UINT, WPARAM, LPARAM);

BOOL CALLBACK EditScheduleDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK EditSQLOptionsDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK EditBackupOptionsDialog(HWND, UINT, WPARAM, LPARAM);

////////////////////////////////////////////////////////////////////////////////////////////

